#include "EventCounter.h"

EventCounter::EventCounter(PinName pin, int initialCount) : input(pin) {
    if (initialCount >= 0 && initialCount < 5)
        count = initialCount;
    else
        count = 0;
    input.rise(this, &EventCounter::event);
    debounce.start();
}

int EventCounter::getCount() {
    return count;
}

void EventCounter::reset() {
    count = 0;
}

void EventCounter::event() {
    if (debounce.read_ms() > 200) {
        ++count;
        count %= 5;
        debounce.reset();
    }
}